# -------- Hanoi.PL ---------------------------------- Ulrich Mller   06.01.04
#                                                      PCS1700 ActivePerl 5.6.1
# Trme von Hanoi mit Hanoi Robot HanoiVBA.HTM

use warnings;
use Win32::OLE;

%Dir  = (Aus  => 0, Ein  => 1, Links   => 1, Rechts => 2);
($mSaule, $mArm, $mGreifer) = (1, 2, 3);
($eArmOben, $eArmUnten) = (3, 4);
($PosA, $PosB, $PosC) = (30, 75, 120);
$RobotPos = 999;
$AnzScheiben = 3;

$ft = Win32::OLE->new("FishFa30.FishFace", 'Quit');
$ft->OpenInterface("COM2");

print "Begibt sich auf Grundstellung\n";
Grundstellung();
Hanoi($AnzScheiben, $PosA, $PosB, $PosC);
$ft->CloseInterface;

sub Hanoi {
  my ($n, $A, $B, $C) = @_;
  if($n == 1) {
    print "Scheibe von $A -> $B\n";
    Ziehe($A, $B);
  } else {
    Hanoi($n-1, $A, $C, $B);
    print "Scheibe von $A -> $B\n";
    Ziehe($A, $B);
    Hanoi($n-1, $C, $B, $A);
  }
}

sub Ziehe {
  my($Von, $Nach) = @_;
  Hole($Von);
  Bringe($Nach);
}

sub Hole {
  my($Pos) = @_;
  SauleNach($Pos);
  ArmSenken();
  ScheibeGreifen();
  ArmHeben();
}

sub Bringe {
  my($Pos) = @_;
  SauleNach($Pos);
  ArmSenken();
  ScheibeLegen();
  ArmHeben();
}

sub Grundstellung {
  $ft->SetMotor($mGreifer, $Dir{Aus});
  ArmHeben();
  $RobotPos = 999;
  SauleNach(0);
  SauleNach($PosA);
}

sub SauleNach{
  my($ZielPos) = @_;
  if($RobotPos < $ZielPos) {
    $ft->SetMotor($mSaule, $Dir{Rechts}, 15, $ZielPos-$RobotPos);
    $ft->WaitForMotors(0, $mSaule);
  } else {
    $ft->SetMotor($mSaule, $Dir{Links}, 15, $RobotPos-$ZielPos);
    $ft->WaitForMotors(0, $mSaule);
  }
  $RobotPos = $ZielPos + $ft->GetCounter(($mSaule-2)*2+2);
}

sub ArmSenken {
  $ft->SetMotor($mArm, $Dir{Links});
  $ft->WaitForInput($eArmUnten);
  $ft->SetMotor($mArm, $Dir{Aus});
}

sub ArmHeben {
  $ft->SetMotor($mArm, $Dir{Rechts});
  $ft->WaitForInput($eArmOben);
  $ft->SetMotor($mArm, $Dir{Aus});
}

sub ScheibeLegen {
  $ft->SetMotor($mGreifer, $Dir{Aus});
}

sub ScheibeGreifen {
  $ft->SetMotor($mGreifer, $Dir{Ein});
}
