'msc303           1           
// --- HanoiRob.JS : Der Hanoi-Roboter   8.10.03 ---

// --- Globale Variable ----------------
var mSaule = 1, mArm = 2, mGreifer = 3;   // --- M-Ausgnge
var eArmOben = 3, eArmUnten = 4;          // --- E-Eingnge
var PosA = 30, PosB = 75, PosC = 120;     // --- Stapelposition
var RobotPos;                             // --- akt. Robotposition

PrintStatus("Begibt sich auf Grundstellung");
Grundstellung();
Hanoi(EA, PosA, PosB, PosC);

function Hanoi(n, TAnf, TMit, TEnd) {
  if (n == 1) {
    PrintStatus("Scheibe von " + TAnf + " -> " + TEnd);
    Ziehe(TAnf, TEnd);
  }
  else {
    Hanoi(n-1, TAnf, TEnd, TMit);
    PrintStatus("Scheibe von " + TAnf + " -> " + TEnd);
    Ziehe(TAnf, TEnd);
    Hanoi(n-1, TMit, TAnf, TEnd);
  }
}

function Ziehe(Von, Nach) {
  Hole(Von);
  Bringe(Nach);
}

function Hole(Pos) {
  SauleNach(Pos);
  ArmSenken();
  ScheibeGreifen();
  ArmHeben();
}

function Bringe(Pos) {
  SauleNach(Pos);
  ArmSenken();
  ScheibeLegen();
  ArmHeben();
}

function Grundstellung() {
  SetMotor(mGreifer, ftiAus);
  ArmHeben();
  RobotPos = 999;
  SauleNach(0);
  SauleNach(PosA);
}

function SauleNach(ZielPos) {
  if (RobotPos < ZielPos) {
    SetMotor(mSaule, ftiRechts, ftiFull, ZielPos-RobotPos);
    WaitForMotors(0, mSaule);
  }
  else {
    SetMotor(mSaule, ftiLinks, ftiFull, RobotPos-ZielPos);
    WaitForMotors(0, mSaule);
  }
  RobotPos = ZielPos + GetCounter((mSaule-1)*2+2);
}

function ArmSenken() {
  SetMotor(mArm, ftiLinks);
  WaitForInput(eArmUnten);
  SetMotor(mArm, ftiAus);
}

function ArmHeben() {
  SetMotor(mArm, ftiRechts);
  WaitForInput(eArmOben);
  SetMotor(mArm, ftiAus);
}

function ScheibeLegen() {
  SetMotor(mGreifer, ftiAus);
}

function ScheibeGreifen() {
  SetMotor(mGreifer, ftiEin);
}
