// -------------------------------------------------------------------------------------
//
// HanoiRob.CS                                                    Ulrich Mller 13.10.03
//                                                                PCS1700  C#.NET  Final
// Lsung des "Turm von Hanoi" Problems mit einem Roboter
// Klasse HanoiRob : Robotnahe Methoden
//
// -------------------------------------------------------------------------------------

using System;
using FishFa30;

namespace HanoiRobot
{
	public class HanoiRob:FishFace
	{
		public HanoiRob(){}

		public int mSaule    = 1;
		public int mArm      = 2;
		public int mGreifer  = 3;
		public int eArmOben  = 3;
		public int eArmUnten = 4;
		public int PosA      = 30;
		public int PosB      = 75;
		public int PosC      = 120;

		private int RobotPos = 999;

		public void Grundstellung()
		{
			SetMotor(mGreifer, (int)Dir.Aus);
			ArmHeben();
			RobotPos = 999;
			SauleNach(0);
			SauleNach(PosA);
		}

		public void SauleNach(int ZielPos)
		{
			if (RobotPos < ZielPos)
				SetMotor(mSaule, (int)Dir.Rechts, (int)Speed.Full, ZielPos-RobotPos);
			else SetMotor(mSaule, (int)Dir.Links, (int)Speed.Full, RobotPos-ZielPos);
			WaitForMotors(0, mSaule);
			RobotPos = ZielPos + GetCounter((mSaule-1)*2+2);
		}

		public void ArmSenken()
		{
			SetMotor(mArm, (int)Dir.Links);
			WaitForInput(eArmUnten);
			SetMotor(mArm, (int)Dir.Aus);
		}

		public void ArmHeben()
		{
			SetMotor(mArm, (int)Dir.Rechts);
			WaitForInput(eArmOben);
			SetMotor(mArm, (int)Dir.Aus);
		}

		public void ScheibeLegen()
		{
			SetMotor(mGreifer, (int)Dir.Aus);
		}

		public void ScheibeGreifen()
		{
			SetMotor(mGreifer, (int)Dir.Ein);
		}
	}
}
