'msc303           1           
// --- HanoiRobC.JS : Der Hanoi-Roboter   8.10.03 ---
//     mit dem Object (Klasse) HanoiRobot -----------

var hr = new HanoiRobot();

PrintStatus("Begibt sich auf Grundstellung");
hr.Grundstellung();
Hanoi(EA, hr.PosA, hr.PosB, hr.PosC);

function Hanoi(n, TAnf, TMit, TEnd) {
  if (n == 1) {
    PrintStatus("Scheibe von " + TAnf + " -> " + TEnd);
    Ziehe(TAnf, TEnd);
  }
  else {
    Hanoi(n-1, TAnf, TEnd, TMit);
    PrintStatus("Scheibe von " + TAnf + " -> " + TEnd);
    Ziehe(TAnf, TEnd);
    Hanoi(n-1, TMit, TAnf, TEnd);
  }
}

function Ziehe(Von, Nach) {
  Hole(Von);
  Bringe(Nach);
}

function Hole(Pos) {
  hr.SauleNach(Pos);
  hr.ArmSenken();
  hr.ScheibeGreifen();
  hr.ArmHeben();
}

function Bringe(Pos) {
  hr.SauleNach(Pos);
  hr.ArmSenken();
  hr.ScheibeLegen();
  hr.ArmHeben();
}

// ---
// --- Object HanoiRobot ------------------------
// ---

function HanoiRobot() {
  this.mSaule    = 1;
  this.mArm      = 2;
  this.mGreifer  = 3;
  this.eArmOben  = 3;
  this.eArmUnten = 4;
  this.PosA      = 30;
  this.PosB      = 75;
  this.PosC      = 120;
  this.RobotPos  = 999;

  this.Grundstellung  = Grundstellung;
  this.SauleNach      = SauleNach;
  this.ArmSenken      = ArmSenken;
  this.ArmHeben       = ArmHeben;
  this.ScheibeLegen   = ScheibeLegen;
  this.ScheibeGreifen = ScheibeGreifen;
}
function Grundstellung() {
  SetMotor(this.mGreifer, ftiAus);
  this.ArmHeben();
  this.RobotPos = 999;
  this.SauleNach(0);
  this.SauleNach(this.PosA);
}

function SauleNach(ZielPos) {
  if (this.RobotPos < ZielPos) {
    SetMotor(this.mSaule, ftiRechts, ftiFull,              ZielPos-this.RobotPos);
    WaitForMotors(0, this.mSaule);
  }
  else {
    SetMotor(this.mSaule, ftiLinks, ftiFull,               this.RobotPos-ZielPos);
    WaitForMotors(0, this.mSaule);
  }
  this.RobotPos = ZielPos + GetCounter((this.mSaule-1)*2+2);
}

function ArmSenken() {
  SetMotor(this.mArm, ftiLinks);
  WaitForInput(this.eArmUnten);
  SetMotor(this.mArm, ftiAus);
}

function ArmHeben() {
  SetMotor(this.mArm, ftiRechts);
  WaitForInput(this.eArmOben);
  SetMotor(this.mArm, ftiAus);
}

function ScheibeLegen() {
  SetMotor(this.mGreifer, ftiAus);
}

function ScheibeGreifen() {
  SetMotor(this.mGreifer, ftiEin);
}

