VERSION 1.0 CLASS
BEGIN
  MultiUse = -1 'True
END
Attribute VB_PredeclaredId = False
Attribute VB_Creatable = True
Attribute VB_Exposed = False
Attribute VB_GlobalNameSpace = False
Attribute VB_Name = "HanoiRobot"
' --- HanoiRobot.CLS : Klasse HanoiRobot zum Betrieb des
'                      des Hanoi-Roboters        5.10.03
Option Explicit

' --- Eigenschaften ------------

Public mSaule&
Public mArm&
Public mGreifer&
Public eArmOben&
Public eArmUnten&
Public PosA&
Public PosB&
Public PosC&

' --- Interne Variable ----------

Private RobotPos&
Private eSauleImpuls&
Private eSauleEnde&

Public Sub Grundstellung()
' --- Fahren auf Grundstellung ---
  SetMotor mGreifer, ftiAus
  ArmHeben
  RobotPos = 999
  SauleNach 0
  SauleNach PosA
End Sub

Public Sub SauleNach(ZielPos&)
' --- Fahren auf ZielPosition --------
  If RobotPos < ZielPos Then
    SetMotor mSaule, ftiRechts, ftiFull, ZielPos-RobotPos
    WaitForMotors 0, mSaule
  Else
    SetMotor mSaule, ftiLinks, ftiFull, RobotPos-ZielPos
    WaitForMotors 0, mSaule
  End If
  RobotPos = ZielPos + GetCounter(eSauleImpuls)
End Sub

Public Sub ArmSenken()
' --- Senken des Greiferarms -----
  SetMotor mArm, ftiLinks
  WaitForInput eArmUnten
  SetMotor mArm, ftiAus
End Sub
Public Sub ArmHeben()
' --- Heben des Greiferarms ------
  SetMotor mArm, ftiRechts
  WaitForInput eArmOben
  SetMotor mArm, ftiAus
End Sub
Public Sub ScheibeLegen()
' --- Ablegen der Scheibe ----
  SetMotor mGreifer, ftiAus
End Sub
Public Sub ScheibeGreifen()
' --- Aufnehmen der Scheibe ---
  SetMotor mGreifer, ftiEin
End Sub
Private Sub Class_Initialize()
' --- Setzen der Standardwerte ---
  mSaule       = 1
  mArm         = 2
  mGreifer     = 3
  eArmOben     = 3
  eArmUnten    = 4
  eSauleImpuls = (mSaule-1)*2+2
  eSauleEnde   = (mSaule-1)*2+1
  PosA         = 30
  PosB         = 75
  PosC         = 120
End Sub
