program poorHanoiRob;
// --- poorHanoiRob.DPR : Der Hanoi-Roboter ------------
//     Achtung : in Men Projekt | Optionen | Linker |
//               TextBildschirmanwendung markieren
//               'COM2' im Hauptprogramm kontrollieren

uses FishFa30, SysUtils;
const
  mSaule = 1; mArm = 2; mGreifer = 3;   // --- M-Ausgnge
  eArmOben = 3; eArmUnten = 4;          // --- E-Eingnge
  PosA = 30; PosB = 75; PosC = 120;     // --- Position der Stapel
var
  ft: TFishFace;
  RobotPos: Integer;                    // --- akt. Robot-Position

procedure Hanoi(n, TAnf, TMit, TEnd: Integer); forward;
procedure Ziehe(Von, Nach: Integer); forward;
procedure Hole(Pos: Integer); forward;
procedure Bringe(Pos: Integer); forward;
procedure Grundstellung(); forward;
procedure SauleNach(ZielPos: Integer); forward;
procedure ArmSenken(); forward;
procedure ArmHeben(); forward;
procedure ScheibeLegen(); forward;
procedure ScheibeGreifen(); forward;

procedure Hanoi(n, TAnf, TMit, TEnd: Integer);
// --- Das Kern-Programm mit der Hanoi-Lsung ---
  begin
    if n = 1 then begin
      WriteLn('Scheibe von ' + IntToStr(TAnf) + ' -> ' + IntToStr(TEnd));
      Ziehe(TAnf, Tend);
      end
    else begin
      Hanoi(n-1, Tanf, TEnd, TMit);
      WriteLn('Scheibe von ' + IntToStr(TAnf) + ' -> ' + IntToStr(TEnd));
      Ziehe(TAnf, TEnd);
      Hanoi(n-1, TMit, TAnf, TEnd);
      end;
  end;

procedure Ziehe(Von, Nach: Integer);
// --- Ziehen einer Scheibe Von -> Nach ---
  begin
    Hole(Von);
    Bringe(Nach);
  end;

procedure Hole(Pos: Integer);
// --- Holen eier Scheibe vom Quellstapel ---
  begin
    SauleNach(Pos);
    ArmSenken();
    ScheibeGreifen();
    ArmHeben();
  end;

procedure Bringe(Pos: Integer);
// --- Bringen einer Scheibe zum Zielstapel ---
  begin
    SauleNach(Pos);
    ArmSenken();
    ScheibeLegen();
    ArmHeben();
  end;

procedure Grundstellung();
// --- Fahren auf Grundstellung ---
  begin
    ft.SetMotor(mGreifer, ftiAus);
    ArmHeben();
    RobotPos := 999;
    SauleNach(0);
    SauleNach(PosA);
  end;

procedure SauleNach(ZielPos: Integer);
// --- Fahren auf ZielPosition ---
  begin
    if RobotPos < ZielPos then begin
      ft.SetMotor(mSaule, ftiRechts, ftiFull, ZielPos-RobotPos);
      ft.WaitForMotors(0, mSaule);
      end
    else begin
      ft.SetMotor(mSaule, ftiLinks, ftiFull, RobotPos-ZielPos);
      ft.WaitForMotors(0, mSaule);
      end;
    RobotPos := ZielPos + ft.GetCounter((mSaule-1)*2+2);
  end;

procedure ArmSenken();
// --- Senken des Greiferarms ---
  begin
    ft.SetMotor(mArm, ftiLinks);
    ft.WaitForInput(eArmUnten);
    ft.SetMotor(mArm, ftiAus);
  end;

procedure ArmHeben();
// --- Heben des Greiferarms ---
  begin
    ft.SetMotor(mArm, ftiRechts);
    ft.WaitForInput(eArmOben);
    ft.SetMotor(mArm, ftiAus);
  end;

procedure ScheibeLegen();
// --- Ablegen der Scheibe ---
  begin
    ft.SetMotor(mGreifer, ftiAus);
  end;

procedure ScheibeGreifen();
// --- Aufnehmen der Scheibe ---
  begin
    ft.SetMotor(mGreifer, ftiEin);
  end;

// ----
// ---- Hauptprogramm ----
// ----

begin
  ft := TFishFace.Create(false,    // --- ohne AnalogScan
                         false);   //     kein Slave
  try
    ft.OpenInterface('COM2');
  except
    on e: EFishFace do begin
      WriteLn('poorFish : InterfaceProblem'); ReadLn; exit;
      end;
  end;
  WriteLn('poorHanoiRob gestartet');
  WriteLn('Begibt sich auf Grundstellung');
  Grundstellung();
  Hanoi(3, PosA, PosB, PosC);
  ft.CloseInterface;
  ft.Free;
  WriteLn('poorHanoiRob beendet'); ReadLn;
end.
